module c_2MUX2 (
     input [9:0] io_in,
     output [3:0] io_out
);

wire [1:0] tnet_0 = io_in[9:8]; //sel
wire [1:0] tnet_1 = tnet_0;
wire [1:0] tnet_2 = io_in[7:6]; //b1
wire [1:0] tnet_3 = io_in[5:4]; //b0
wire [1:0] tnet_4 = io_in[3:2]; //a1
wire [1:0] tnet_5 = io_in[1:0]; //a0

wire [1:0] tnet_6;
wire [1:0] tnet_7;

assign io_out[3:2] = tnet_6; //q1
assign io_out[1:0] = tnet_7; //q0

c_2MUX1 SavedGate_0 (
.io_in({tnet_0,tnet_2,tnet_4}),
.io_out({tnet_6})
);

c_2MUX1 SavedGate_1 (
.io_in({tnet_1,tnet_3,tnet_5}),
.io_out({tnet_7})
);

endmodule

module c_2MUX1 (
     input [5:0] io_in,
     output [1:0] io_out
);

wire [1:0] tnet_0 = io_in[5:4]; //sel
wire [1:0] tnet_1 = io_in[3:2]; //b
wire [1:0] tnet_2 = io_in[1:0]; //a

wire [1:0] tnet_3;

assign io_out[1:0] = tnet_3; //q

f_PPPPPPZD0_bet LogicGate_0 (
.portC(tnet_0),
.portB(tnet_1),
.portA(tnet_2),
.out(tnet_3)
);

endmodule

module f_PPPPPPZD0_bet (
     input wire[1:0] portC,
     input wire[1:0] portB,
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portC == 2'b01) & (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b01) & (portB == 2'b11) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b01) & (portB == 2'b10) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b01) & (portB == 2'b01) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b01) & (portB == 2'b11) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b01) & (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b11) & (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b11) & (portB == 2'b10) & (portA == 2'b01) ? 2'b10 :
    (portC == 2'b11) & (portB == 2'b01) & (portA == 2'b11) ? 2'b01 :
    (portC == 2'b11) & (portB == 2'b10) & (portA == 2'b11) ? 2'b10 :
    (portC == 2'b11) & (portB == 2'b01) & (portA == 2'b10) ? 2'b01 :
    (portC == 2'b11) & (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b10) & (portB == 2'b10) & (portA == 2'b01) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b01) & (portA == 2'b11) ? 2'b01 :
    (portC == 2'b10) & (portB == 2'b10) & (portA == 2'b11) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b01) & (portA == 2'b10) ? 2'b01 :
    (portC == 2'b10) & (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
     2'b11;
endmodule

