module c_8REGARRAY2 (
     input [12:0] io_in,
     output [35:0] io_out
);

wire bnet_0 = io_in[12]; //write8
wire bnet_1 = io_in[11]; //write7
wire bnet_2 = io_in[10]; //write6
wire bnet_3 = io_in[9]; //write5
wire bnet_4 = io_in[8]; //write4
wire bnet_5 = io_in[7]; //write3
wire bnet_6 = io_in[6]; //write2
wire bnet_7 = io_in[5]; //write1
wire bnet_8 = io_in[4]; //write0
wire [1:0] tnet_9 = io_in[3:2]; //dataIn1
wire [1:0] tnet_10 = tnet_9;
wire [1:0] tnet_11 = tnet_9;
wire [1:0] tnet_12 = tnet_9;
wire [1:0] tnet_13 = tnet_9;
wire [1:0] tnet_14 = tnet_9;
wire [1:0] tnet_15 = tnet_9;
wire [1:0] tnet_16 = tnet_9;
wire [1:0] tnet_17 = tnet_9;
wire [1:0] tnet_18 = io_in[1:0]; //dataIn0
wire [1:0] tnet_19 = tnet_18;
wire [1:0] tnet_20 = tnet_18;
wire [1:0] tnet_21 = tnet_18;
wire [1:0] tnet_22 = tnet_18;
wire [1:0] tnet_23 = tnet_18;
wire [1:0] tnet_24 = tnet_18;
wire [1:0] tnet_25 = tnet_18;
wire [1:0] tnet_26 = tnet_18;

wire [1:0] tnet_27;
wire [1:0] tnet_28;
wire [1:0] tnet_29;
wire [1:0] tnet_30;
wire [1:0] tnet_31;
wire [1:0] tnet_32;
wire [1:0] tnet_33;
wire [1:0] tnet_34;
wire [1:0] tnet_35;
wire [1:0] tnet_36;
wire [1:0] tnet_37;
wire [1:0] tnet_38;
wire [1:0] tnet_39;
wire [1:0] tnet_40;
wire [1:0] tnet_41;
wire [1:0] tnet_42;
wire [1:0] tnet_43;
wire [1:0] tnet_44;

assign io_out[35:34] = tnet_27; //dOut81
assign io_out[33:32] = tnet_28; //dOut80
assign io_out[31:30] = tnet_29; //dOut71
assign io_out[29:28] = tnet_30; //dOut70
assign io_out[27:26] = tnet_31; //dOut61
assign io_out[25:24] = tnet_32; //dOut60
assign io_out[23:22] = tnet_33; //dOut51
assign io_out[21:20] = tnet_34; //dOut50
assign io_out[19:18] = tnet_35; //dOut41
assign io_out[17:16] = tnet_36; //dOut40
assign io_out[15:14] = tnet_37; //dOut31
assign io_out[13:12] = tnet_38; //dOut30
assign io_out[11:10] = tnet_39; //dOut21
assign io_out[9:8] = tnet_40; //dOut20
assign io_out[7:6] = tnet_41; //dOut11
assign io_out[5:4] = tnet_42; //dOut10
assign io_out[3:2] = tnet_43; //dOut01
assign io_out[1:0] = tnet_44; //dOut00

c_1Latch2 SavedGate_0 (
.io_in({bnet_0,tnet_9,tnet_18}),
.io_out({tnet_27,tnet_28})
);

c_1Latch2 SavedGate_1 (
.io_in({bnet_1,tnet_10,tnet_19}),
.io_out({tnet_29,tnet_30})
);

c_1Latch2 SavedGate_2 (
.io_in({bnet_2,tnet_11,tnet_20}),
.io_out({tnet_31,tnet_32})
);

c_1Latch2 SavedGate_3 (
.io_in({bnet_3,tnet_12,tnet_21}),
.io_out({tnet_33,tnet_34})
);

c_1Latch2 SavedGate_4 (
.io_in({bnet_4,tnet_13,tnet_22}),
.io_out({tnet_35,tnet_36})
);

c_1Latch2 SavedGate_5 (
.io_in({bnet_5,tnet_14,tnet_23}),
.io_out({tnet_37,tnet_38})
);

c_1Latch2 SavedGate_6 (
.io_in({bnet_6,tnet_15,tnet_24}),
.io_out({tnet_39,tnet_40})
);

c_1Latch2 SavedGate_7 (
.io_in({bnet_7,tnet_16,tnet_25}),
.io_out({tnet_41,tnet_42})
);

c_1Latch2 SavedGate_8 (
.io_in({bnet_8,tnet_17,tnet_26}),
.io_out({tnet_43,tnet_44})
);

endmodule

module c_1Latch2 (
     input [4:0] io_in,
     output [3:0] io_out
);

wire bnet_0 = io_in[4]; //write
wire bnet_1 = bnet_0;
wire [1:0] tnet_2 = io_in[3:2]; //a1
wire [1:0] tnet_3 = io_in[1:0]; //a0

wire [1:0] tnet_4;
wire [1:0] tnet_5;

assign io_out[3:2] = tnet_4; //q1
assign io_out[1:0] = tnet_5; //q0

c_BTLatch SavedGate_0 (
.io_in({bnet_0,tnet_2}),
.io_out({tnet_4})
);

c_BTLatch SavedGate_1 (
.io_in({bnet_1,tnet_3}),
.io_out({tnet_5})
);

endmodule

module c_BTLatch (
     input [2:0] io_in,
     output [1:0] io_out
);

wire bnet_0 = io_in[2]; //DataIn
wire [1:0] tnet_1 = io_in[1:0]; //DataIn

wire [1:0] tnet_2;
wire [1:0] tnet_3 = tnet_2;

assign io_out[1:0] = tnet_3; //DataOut

f_ZD0PPPPPP_bet LogicGate_0 (
.portC({bnet_0,!bnet_0}),
.portA(tnet_1),
.portB(tnet_2),
.out(tnet_2)
);

endmodule

module f_ZD0PPPPPP_bet (
     input wire[1:0] portC,
     input wire[1:0] portB,
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portC == 2'b01) & (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b01) & (portB == 2'b10) & (portA == 2'b01) ? 2'b10 :
    (portC == 2'b01) & (portB == 2'b01) & (portA == 2'b11) ? 2'b01 :
    (portC == 2'b01) & (portB == 2'b10) & (portA == 2'b11) ? 2'b10 :
    (portC == 2'b01) & (portB == 2'b01) & (portA == 2'b10) ? 2'b01 :
    (portC == 2'b01) & (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b11) & (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b11) & (portB == 2'b10) & (portA == 2'b01) ? 2'b10 :
    (portC == 2'b11) & (portB == 2'b01) & (portA == 2'b11) ? 2'b01 :
    (portC == 2'b11) & (portB == 2'b10) & (portA == 2'b11) ? 2'b10 :
    (portC == 2'b11) & (portB == 2'b01) & (portA == 2'b10) ? 2'b01 :
    (portC == 2'b11) & (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b10) & (portB == 2'b11) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b10) & (portB == 2'b10) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b10) & (portB == 2'b01) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b11) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
     2'b11;
endmodule

