module c_9BDEMUX1 (
     input [4:0] io_in,
     output [8:0] io_out
);

wire [1:0] tnet_0 = io_in[4:3]; //sel1
wire [1:0] tnet_1 = io_in[2:1]; //sel0
wire [1:0] tnet_2 = tnet_1;
wire [1:0] tnet_3 = tnet_1;
wire bnet_4 = io_in[0]; //clkIn

wire bnet_5;
wire bnet_6;
wire bnet_7;
wire bnet_8;
wire bnet_9;
wire bnet_10;
wire bnet_11;
wire bnet_12;
wire bnet_13;
wire bnet_14;
wire bnet_15;
wire bnet_16;

assign io_out[8] = bnet_8; //clkOut8
assign io_out[7] = bnet_9; //clkOut7
assign io_out[6] = bnet_10; //clkOut6
assign io_out[5] = bnet_11; //clkOut5
assign io_out[4] = bnet_12; //clkOut4
assign io_out[3] = bnet_13; //clkOut3
assign io_out[2] = bnet_14; //clkOut2
assign io_out[1] = bnet_15; //clkOut1
assign io_out[0] = bnet_16; //clkOut0

c_3DEMUX SavedGate_0 (
.io_in({tnet_3,bnet_7}),
.io_out({bnet_8,bnet_9,bnet_10})
);

c_3DEMUX SavedGate_1 (
.io_in({tnet_2,bnet_6}),
.io_out({bnet_11,bnet_12,bnet_13})
);

c_3DEMUX SavedGate_2 (
.io_in({tnet_0,bnet_4}),
.io_out({bnet_7,bnet_6,bnet_5})
);

c_3DEMUX SavedGate_3 (
.io_in({tnet_1,bnet_5}),
.io_out({bnet_14,bnet_15,bnet_16})
);

endmodule

module c_3DEMUX (
     input [2:0] io_in,
     output [2:0] io_out
);

wire [1:0] tnet_0 = io_in[2:1]; //DataIn
wire [1:0] tnet_1 = tnet_0;
wire [1:0] tnet_2 = tnet_0;
wire bnet_3 = io_in[0]; //Clock
wire bnet_4 = bnet_3;
wire bnet_5 = bnet_3;

wire [1:0] tnet_6;
wire [1:0] tnet_7;
wire [1:0] tnet_8;

assign io_out[2] = tnet_6[1]; //DataOut
assign io_out[1] = tnet_7[1]; //DataOut
assign io_out[0] = tnet_8[1]; //DataOut

f_200_bet LogicGate_0 (
.portB(tnet_0),
.portA({bnet_3,!bnet_3}),
.out(tnet_6)
);

f_600_bet LogicGate_1 (
.portB(tnet_1),
.portA({bnet_4,!bnet_4}),
.out(tnet_7)
);

f_K00_bet LogicGate_2 (
.portB(tnet_2),
.portA({bnet_5,!bnet_5}),
.out(tnet_8)
);

endmodule

module f_200_bet (
     input wire[1:0] portB,
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b11) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b10) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b01) & (portA == 2'b11) ? 2'b01 :
    (portB == 2'b11) & (portA == 2'b11) ? 2'b01 :
    (portB == 2'b10) & (portA == 2'b11) ? 2'b01 :
    (portB == 2'b01) & (portA == 2'b10) ? 2'b10 :
    (portB == 2'b11) & (portA == 2'b10) ? 2'b01 :
    (portB == 2'b10) & (portA == 2'b10) ? 2'b01 :
     2'b11;
endmodule

module f_600_bet (
     input wire[1:0] portB,
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b11) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b10) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b01) & (portA == 2'b11) ? 2'b01 :
    (portB == 2'b11) & (portA == 2'b11) ? 2'b01 :
    (portB == 2'b10) & (portA == 2'b11) ? 2'b01 :
    (portB == 2'b01) & (portA == 2'b10) ? 2'b01 :
    (portB == 2'b11) & (portA == 2'b10) ? 2'b10 :
    (portB == 2'b10) & (portA == 2'b10) ? 2'b01 :
     2'b11;
endmodule

module f_K00_bet (
     input wire[1:0] portB,
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b11) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b10) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b01) & (portA == 2'b11) ? 2'b01 :
    (portB == 2'b11) & (portA == 2'b11) ? 2'b01 :
    (portB == 2'b10) & (portA == 2'b11) ? 2'b01 :
    (portB == 2'b01) & (portA == 2'b10) ? 2'b01 :
    (portB == 2'b11) & (portA == 2'b10) ? 2'b01 :
    (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
     2'b11;
endmodule

