module c_9REG2 (
     input [16:0] io_in,
     output [7:0] io_out
);

wire [1:0] tnet_0 = io_in[16:15]; //ReadAddr11
wire [1:0] tnet_1 = io_in[14:13]; //ReadAddr10
wire [1:0] tnet_2 = io_in[12:11]; //ReadAddr01
wire [1:0] tnet_3 = io_in[10:9]; //ReadAddr00
wire [1:0] tnet_4 = io_in[8:7]; //WriteAddr1
wire [1:0] tnet_5 = io_in[6:5]; //WriteAddr0
wire [1:0] tnet_6 = io_in[4:3]; //WriteData1
wire [1:0] tnet_7 = io_in[2:1]; //WriteData0
wire bnet_8 = io_in[0]; //RegWrite

wire bnet_9;
wire bnet_10;
wire bnet_11;
wire bnet_12;
wire bnet_13;
wire bnet_14;
wire bnet_15;
wire bnet_16;
wire bnet_17;
wire [1:0] tnet_18;
wire [1:0] tnet_19;
wire [1:0] tnet_20;
wire [1:0] tnet_21;
wire [1:0] tnet_22;
wire [1:0] tnet_23;
wire [1:0] tnet_24;
wire [1:0] tnet_25;
wire [1:0] tnet_26;
wire [1:0] tnet_27;
wire [1:0] tnet_28;
wire [1:0] tnet_29;
wire [1:0] tnet_30;
wire [1:0] tnet_31;
wire [1:0] tnet_32;
wire [1:0] tnet_33;
wire [1:0] tnet_34;
wire [1:0] tnet_35;
wire [1:0] tnet_36 = tnet_18;
wire [1:0] tnet_37 = tnet_19;
wire [1:0] tnet_38 = tnet_20;
wire [1:0] tnet_39 = tnet_21;
wire [1:0] tnet_40 = tnet_22;
wire [1:0] tnet_41 = tnet_23;
wire [1:0] tnet_42 = tnet_24;
wire [1:0] tnet_43 = tnet_25;
wire [1:0] tnet_44 = tnet_26;
wire [1:0] tnet_45 = tnet_27;
wire [1:0] tnet_46 = tnet_28;
wire [1:0] tnet_47 = tnet_29;
wire [1:0] tnet_48 = tnet_30;
wire [1:0] tnet_49 = tnet_31;
wire [1:0] tnet_50 = tnet_32;
wire [1:0] tnet_51 = tnet_33;
wire [1:0] tnet_52 = tnet_34;
wire [1:0] tnet_53 = tnet_35;
wire [1:0] tnet_54;
wire [1:0] tnet_55;
wire [1:0] tnet_56;
wire [1:0] tnet_57;

assign io_out[7:6] = tnet_54; //ReadData11
assign io_out[5:4] = tnet_55; //ReadData10
assign io_out[3:2] = tnet_56; //ReadData01
assign io_out[1:0] = tnet_57; //ReadData00

c_9MUX2 SavedGate_0 (
.io_in({tnet_0,tnet_1,tnet_35,tnet_34,tnet_33,tnet_32,tnet_31,tnet_30,tnet_29,tnet_28,tnet_27,tnet_26,tnet_25,tnet_24,tnet_23,tnet_22,tnet_21,tnet_20,tnet_19,tnet_18}),
.io_out({tnet_54,tnet_55})
);

c_9BDEMUX1 SavedGate_1 (
.io_in({tnet_4,tnet_5,bnet_8}),
.io_out({bnet_17,bnet_16,bnet_15,bnet_14,bnet_13,bnet_12,bnet_11,bnet_10,bnet_9})
);

c_8REGARRAY2 SavedGate_2 (
.io_in({bnet_17,bnet_16,bnet_15,bnet_14,bnet_13,bnet_12,bnet_11,bnet_10,bnet_9,tnet_6,tnet_7}),
.io_out({tnet_35,tnet_34,tnet_33,tnet_32,tnet_31,tnet_30,tnet_29,tnet_28,tnet_27,tnet_26,tnet_25,tnet_24,tnet_23,tnet_22,tnet_21,tnet_20,tnet_19,tnet_18})
);

c_9MUX2 SavedGate_3 (
.io_in({tnet_2,tnet_3,tnet_53,tnet_52,tnet_51,tnet_50,tnet_49,tnet_48,tnet_47,tnet_46,tnet_45,tnet_44,tnet_43,tnet_42,tnet_41,tnet_40,tnet_39,tnet_38,tnet_37,tnet_36}),
.io_out({tnet_56,tnet_57})
);

endmodule

module c_1Latch2 (
     input [4:0] io_in,
     output [3:0] io_out
);

wire bnet_0 = io_in[4]; //write
wire bnet_1 = bnet_0;
wire [1:0] tnet_2 = io_in[3:2]; //a1
wire [1:0] tnet_3 = io_in[1:0]; //a0

wire [1:0] tnet_4;
wire [1:0] tnet_5;

assign io_out[3:2] = tnet_4; //q1
assign io_out[1:0] = tnet_5; //q0

c_BTLatch SavedGate_0 (
.io_in({bnet_0,tnet_2}),
.io_out({tnet_4})
);

c_BTLatch SavedGate_1 (
.io_in({bnet_1,tnet_3}),
.io_out({tnet_5})
);

endmodule

module c_3DEMUX (
     input [2:0] io_in,
     output [2:0] io_out
);

wire [1:0] tnet_0 = io_in[2:1]; //DataIn
wire [1:0] tnet_1 = tnet_0;
wire [1:0] tnet_2 = tnet_0;
wire bnet_3 = io_in[0]; //Clock
wire bnet_4 = bnet_3;
wire bnet_5 = bnet_3;

wire [1:0] tnet_6;
wire [1:0] tnet_7;
wire [1:0] tnet_8;

assign io_out[2] = tnet_6[1]; //DataOut
assign io_out[1] = tnet_7[1]; //DataOut
assign io_out[0] = tnet_8[1]; //DataOut

f_200_bet LogicGate_0 (
.portB(tnet_0),
.portA({bnet_3,!bnet_3}),
.out(tnet_6)
);

f_600_bet LogicGate_1 (
.portB(tnet_1),
.portA({bnet_4,!bnet_4}),
.out(tnet_7)
);

f_K00_bet LogicGate_2 (
.portB(tnet_2),
.portA({bnet_5,!bnet_5}),
.out(tnet_8)
);

endmodule

module c_3MUX1 (
     input [7:0] io_in,
     output [1:0] io_out
);

wire [1:0] tnet_0 = io_in[7:6]; //sel
wire [1:0] tnet_1 = tnet_0;
wire [1:0] tnet_2 = io_in[5:4]; //c
wire [1:0] tnet_3 = io_in[3:2]; //b
wire [1:0] tnet_4 = io_in[1:0]; //a

wire [1:0] tnet_5;
wire [1:0] tnet_6;

assign io_out[1:0] = tnet_6; //out

f_PPPZD0ZD0_bet LogicGate_0 (
.portC(tnet_0),
.portB(tnet_2),
.portA(tnet_5),
.out(tnet_6)
);

f_RPPRPPZD0_bet LogicGate_1 (
.portC(tnet_1),
.portB(tnet_3),
.portA(tnet_4),
.out(tnet_5)
);

endmodule

module c_3MUX2 (
     input [13:0] io_in,
     output [3:0] io_out
);

wire [1:0] tnet_0 = io_in[13:12]; //sel
wire [1:0] tnet_1 = tnet_0;
wire [1:0] tnet_2 = io_in[11:10]; //c1
wire [1:0] tnet_3 = io_in[9:8]; //c0
wire [1:0] tnet_4 = io_in[7:6]; //b1
wire [1:0] tnet_5 = io_in[5:4]; //b0
wire [1:0] tnet_6 = io_in[3:2]; //a1
wire [1:0] tnet_7 = io_in[1:0]; //a0

wire [1:0] tnet_8;
wire [1:0] tnet_9;

assign io_out[3:2] = tnet_8; //q1
assign io_out[1:0] = tnet_9; //q0

c_3MUX1 SavedGate_0 (
.io_in({tnet_0,tnet_2,tnet_4,tnet_6}),
.io_out({tnet_8})
);

c_3MUX1 SavedGate_1 (
.io_in({tnet_1,tnet_3,tnet_5,tnet_7}),
.io_out({tnet_9})
);

endmodule

module c_8REGARRAY2 (
     input [12:0] io_in,
     output [35:0] io_out
);

wire bnet_0 = io_in[12]; //write8
wire bnet_1 = io_in[11]; //write7
wire bnet_2 = io_in[10]; //write6
wire bnet_3 = io_in[9]; //write5
wire bnet_4 = io_in[8]; //write4
wire bnet_5 = io_in[7]; //write3
wire bnet_6 = io_in[6]; //write2
wire bnet_7 = io_in[5]; //write1
wire bnet_8 = io_in[4]; //write0
wire [1:0] tnet_9 = io_in[3:2]; //dataIn1
wire [1:0] tnet_10 = tnet_9;
wire [1:0] tnet_11 = tnet_9;
wire [1:0] tnet_12 = tnet_9;
wire [1:0] tnet_13 = tnet_9;
wire [1:0] tnet_14 = tnet_9;
wire [1:0] tnet_15 = tnet_9;
wire [1:0] tnet_16 = tnet_9;
wire [1:0] tnet_17 = tnet_9;
wire [1:0] tnet_18 = io_in[1:0]; //dataIn0
wire [1:0] tnet_19 = tnet_18;
wire [1:0] tnet_20 = tnet_18;
wire [1:0] tnet_21 = tnet_18;
wire [1:0] tnet_22 = tnet_18;
wire [1:0] tnet_23 = tnet_18;
wire [1:0] tnet_24 = tnet_18;
wire [1:0] tnet_25 = tnet_18;
wire [1:0] tnet_26 = tnet_18;

wire [1:0] tnet_27;
wire [1:0] tnet_28;
wire [1:0] tnet_29;
wire [1:0] tnet_30;
wire [1:0] tnet_31;
wire [1:0] tnet_32;
wire [1:0] tnet_33;
wire [1:0] tnet_34;
wire [1:0] tnet_35;
wire [1:0] tnet_36;
wire [1:0] tnet_37;
wire [1:0] tnet_38;
wire [1:0] tnet_39;
wire [1:0] tnet_40;
wire [1:0] tnet_41;
wire [1:0] tnet_42;
wire [1:0] tnet_43;
wire [1:0] tnet_44;

assign io_out[35:34] = tnet_27; //dOut81
assign io_out[33:32] = tnet_28; //dOut80
assign io_out[31:30] = tnet_29; //dOut71
assign io_out[29:28] = tnet_30; //dOut70
assign io_out[27:26] = tnet_31; //dOut61
assign io_out[25:24] = tnet_32; //dOut60
assign io_out[23:22] = tnet_33; //dOut51
assign io_out[21:20] = tnet_34; //dOut50
assign io_out[19:18] = tnet_35; //dOut41
assign io_out[17:16] = tnet_36; //dOut40
assign io_out[15:14] = tnet_37; //dOut31
assign io_out[13:12] = tnet_38; //dOut30
assign io_out[11:10] = tnet_39; //dOut21
assign io_out[9:8] = tnet_40; //dOut20
assign io_out[7:6] = tnet_41; //dOut11
assign io_out[5:4] = tnet_42; //dOut10
assign io_out[3:2] = tnet_43; //dOut01
assign io_out[1:0] = tnet_44; //dOut00

c_1Latch2 SavedGate_0 (
.io_in({bnet_0,tnet_9,tnet_18}),
.io_out({tnet_27,tnet_28})
);

c_1Latch2 SavedGate_1 (
.io_in({bnet_1,tnet_10,tnet_19}),
.io_out({tnet_29,tnet_30})
);

c_1Latch2 SavedGate_2 (
.io_in({bnet_2,tnet_11,tnet_20}),
.io_out({tnet_31,tnet_32})
);

c_1Latch2 SavedGate_3 (
.io_in({bnet_3,tnet_12,tnet_21}),
.io_out({tnet_33,tnet_34})
);

c_1Latch2 SavedGate_4 (
.io_in({bnet_4,tnet_13,tnet_22}),
.io_out({tnet_35,tnet_36})
);

c_1Latch2 SavedGate_5 (
.io_in({bnet_5,tnet_14,tnet_23}),
.io_out({tnet_37,tnet_38})
);

c_1Latch2 SavedGate_6 (
.io_in({bnet_6,tnet_15,tnet_24}),
.io_out({tnet_39,tnet_40})
);

c_1Latch2 SavedGate_7 (
.io_in({bnet_7,tnet_16,tnet_25}),
.io_out({tnet_41,tnet_42})
);

c_1Latch2 SavedGate_8 (
.io_in({bnet_8,tnet_17,tnet_26}),
.io_out({tnet_43,tnet_44})
);

endmodule

module c_9BDEMUX1 (
     input [4:0] io_in,
     output [8:0] io_out
);

wire [1:0] tnet_0 = io_in[4:3]; //sel1
wire [1:0] tnet_1 = io_in[2:1]; //sel0
wire [1:0] tnet_2 = tnet_1;
wire [1:0] tnet_3 = tnet_1;
wire bnet_4 = io_in[0]; //clkIn

wire bnet_5;
wire bnet_6;
wire bnet_7;
wire bnet_8;
wire bnet_9;
wire bnet_10;
wire bnet_11;
wire bnet_12;
wire bnet_13;
wire bnet_14;
wire bnet_15;
wire bnet_16;

assign io_out[8] = bnet_8; //clkOut8
assign io_out[7] = bnet_9; //clkOut7
assign io_out[6] = bnet_10; //clkOut6
assign io_out[5] = bnet_11; //clkOut5
assign io_out[4] = bnet_12; //clkOut4
assign io_out[3] = bnet_13; //clkOut3
assign io_out[2] = bnet_14; //clkOut2
assign io_out[1] = bnet_15; //clkOut1
assign io_out[0] = bnet_16; //clkOut0

c_3DEMUX SavedGate_0 (
.io_in({tnet_3,bnet_7}),
.io_out({bnet_8,bnet_9,bnet_10})
);

c_3DEMUX SavedGate_1 (
.io_in({tnet_2,bnet_6}),
.io_out({bnet_11,bnet_12,bnet_13})
);

c_3DEMUX SavedGate_2 (
.io_in({tnet_0,bnet_4}),
.io_out({bnet_7,bnet_6,bnet_5})
);

c_3DEMUX SavedGate_3 (
.io_in({tnet_1,bnet_5}),
.io_out({bnet_14,bnet_15,bnet_16})
);

endmodule

module c_9MUX2 (
     input [39:0] io_in,
     output [3:0] io_out
);

wire [1:0] tnet_0 = io_in[39:38]; //sel1
wire [1:0] tnet_1 = io_in[37:36]; //sel0
wire [1:0] tnet_2 = tnet_1;
wire [1:0] tnet_3 = tnet_1;
wire [1:0] tnet_4 = io_in[35:34]; //dIn81
wire [1:0] tnet_5 = io_in[33:32]; //dIn80
wire [1:0] tnet_6 = io_in[31:30]; //dIn71
wire [1:0] tnet_7 = io_in[29:28]; //dIn70
wire [1:0] tnet_8 = io_in[27:26]; //dIn61
wire [1:0] tnet_9 = io_in[25:24]; //dIn60
wire [1:0] tnet_10 = io_in[23:22]; //dIn51
wire [1:0] tnet_11 = io_in[21:20]; //dIn50
wire [1:0] tnet_12 = io_in[19:18]; //dIn41
wire [1:0] tnet_13 = io_in[17:16]; //dIn40
wire [1:0] tnet_14 = io_in[15:14]; //dIn31
wire [1:0] tnet_15 = io_in[13:12]; //dIn30
wire [1:0] tnet_16 = io_in[11:10]; //dIn21
wire [1:0] tnet_17 = io_in[9:8]; //dIn20
wire [1:0] tnet_18 = io_in[7:6]; //dIn11
wire [1:0] tnet_19 = io_in[5:4]; //dIn10
wire [1:0] tnet_20 = io_in[3:2]; //dIn01
wire [1:0] tnet_21 = io_in[1:0]; //dIn00

wire [1:0] tnet_22;
wire [1:0] tnet_23;
wire [1:0] tnet_24;
wire [1:0] tnet_25;
wire [1:0] tnet_26;
wire [1:0] tnet_27;
wire [1:0] tnet_28;
wire [1:0] tnet_29;

assign io_out[3:2] = tnet_28; //dOut1
assign io_out[1:0] = tnet_29; //dOut0

c_3MUX2 SavedGate_0 (
.io_in({tnet_3,tnet_4,tnet_5,tnet_6,tnet_7,tnet_8,tnet_9}),
.io_out({tnet_22,tnet_23})
);

c_3MUX2 SavedGate_1 (
.io_in({tnet_0,tnet_22,tnet_23,tnet_24,tnet_25,tnet_26,tnet_27}),
.io_out({tnet_28,tnet_29})
);

c_3MUX2 SavedGate_2 (
.io_in({tnet_2,tnet_10,tnet_11,tnet_12,tnet_13,tnet_14,tnet_15}),
.io_out({tnet_24,tnet_25})
);

c_3MUX2 SavedGate_3 (
.io_in({tnet_1,tnet_16,tnet_17,tnet_18,tnet_19,tnet_20,tnet_21}),
.io_out({tnet_26,tnet_27})
);

endmodule

module c_BTLatch (
     input [2:0] io_in,
     output [1:0] io_out
);

wire bnet_0 = io_in[2]; //DataIn
wire [1:0] tnet_1 = io_in[1:0]; //DataIn

wire [1:0] tnet_2;
wire [1:0] tnet_3 = tnet_2;

assign io_out[1:0] = tnet_3; //DataOut

f_ZD0PPPPPP_bet LogicGate_0 (
.portC({bnet_0,!bnet_0}),
.portA(tnet_1),
.portB(tnet_2),
.out(tnet_2)
);

endmodule

module f_200_bet (
     input wire[1:0] portB,
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b11) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b10) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b01) & (portA == 2'b11) ? 2'b01 :
    (portB == 2'b11) & (portA == 2'b11) ? 2'b01 :
    (portB == 2'b10) & (portA == 2'b11) ? 2'b01 :
    (portB == 2'b01) & (portA == 2'b10) ? 2'b10 :
    (portB == 2'b11) & (portA == 2'b10) ? 2'b01 :
    (portB == 2'b10) & (portA == 2'b10) ? 2'b01 :
     2'b11;
endmodule

module f_600_bet (
     input wire[1:0] portB,
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b11) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b10) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b01) & (portA == 2'b11) ? 2'b01 :
    (portB == 2'b11) & (portA == 2'b11) ? 2'b01 :
    (portB == 2'b10) & (portA == 2'b11) ? 2'b01 :
    (portB == 2'b01) & (portA == 2'b10) ? 2'b01 :
    (portB == 2'b11) & (portA == 2'b10) ? 2'b10 :
    (portB == 2'b10) & (portA == 2'b10) ? 2'b01 :
     2'b11;
endmodule

module f_K00_bet (
     input wire[1:0] portB,
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b11) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b10) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b01) & (portA == 2'b11) ? 2'b01 :
    (portB == 2'b11) & (portA == 2'b11) ? 2'b01 :
    (portB == 2'b10) & (portA == 2'b11) ? 2'b01 :
    (portB == 2'b01) & (portA == 2'b10) ? 2'b01 :
    (portB == 2'b11) & (portA == 2'b10) ? 2'b01 :
    (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
     2'b11;
endmodule

module f_PPPZD0ZD0_bet (
     input wire[1:0] portC,
     input wire[1:0] portB,
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portC == 2'b01) & (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b01) & (portB == 2'b11) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b01) & (portB == 2'b10) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b01) & (portB == 2'b01) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b01) & (portB == 2'b11) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b01) & (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b11) & (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b11) & (portB == 2'b11) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b11) & (portB == 2'b10) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b11) & (portB == 2'b01) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b11) & (portB == 2'b11) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b11) & (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b10) & (portB == 2'b10) & (portA == 2'b01) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b01) & (portA == 2'b11) ? 2'b01 :
    (portC == 2'b10) & (portB == 2'b10) & (portA == 2'b11) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b01) & (portA == 2'b10) ? 2'b01 :
    (portC == 2'b10) & (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
     2'b11;
endmodule

module f_RPPRPPZD0_bet (
     input wire[1:0] portC,
     input wire[1:0] portB,
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portC == 2'b01) & (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b01) & (portB == 2'b11) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b01) & (portB == 2'b10) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b01) & (portB == 2'b01) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b01) & (portB == 2'b11) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b01) & (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b11) & (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b11) & (portB == 2'b10) & (portA == 2'b01) ? 2'b10 :
    (portC == 2'b11) & (portB == 2'b01) & (portA == 2'b11) ? 2'b01 :
    (portC == 2'b11) & (portB == 2'b10) & (portA == 2'b11) ? 2'b10 :
    (portC == 2'b11) & (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b10) & (portB == 2'b10) & (portA == 2'b01) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b01) & (portA == 2'b11) ? 2'b01 :
    (portC == 2'b10) & (portB == 2'b10) & (portA == 2'b11) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
     2'b11;
endmodule

module f_ZD0PPPPPP_bet (
     input wire[1:0] portC,
     input wire[1:0] portB,
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portC == 2'b01) & (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b01) & (portB == 2'b10) & (portA == 2'b01) ? 2'b10 :
    (portC == 2'b01) & (portB == 2'b01) & (portA == 2'b11) ? 2'b01 :
    (portC == 2'b01) & (portB == 2'b10) & (portA == 2'b11) ? 2'b10 :
    (portC == 2'b01) & (portB == 2'b01) & (portA == 2'b10) ? 2'b01 :
    (portC == 2'b01) & (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b11) & (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b11) & (portB == 2'b10) & (portA == 2'b01) ? 2'b10 :
    (portC == 2'b11) & (portB == 2'b01) & (portA == 2'b11) ? 2'b01 :
    (portC == 2'b11) & (portB == 2'b10) & (portA == 2'b11) ? 2'b10 :
    (portC == 2'b11) & (portB == 2'b01) & (portA == 2'b10) ? 2'b01 :
    (portC == 2'b11) & (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b10) & (portB == 2'b11) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b10) & (portB == 2'b10) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b10) & (portB == 2'b01) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b11) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
     2'b11;
endmodule

