module c_CPUctrl (
     input [9:0] io_in,
     output [19:0] io_out
);

wire [1:0] tnet_0 = io_in[9:8]; //opcode1
wire [1:0] tnet_1 = tnet_0;
wire [1:0] tnet_2 = tnet_0;
wire [1:0] tnet_3 = tnet_0;
wire [1:0] tnet_4 = tnet_0;
wire [1:0] tnet_5 = tnet_0;
wire [1:0] tnet_6 = tnet_0;
wire [1:0] tnet_7 = io_in[7:6]; //opcode0
wire [1:0] tnet_8 = tnet_7;
wire [1:0] tnet_9 = tnet_7;
wire [1:0] tnet_10 = tnet_7;
wire [1:0] tnet_11 = tnet_7;
wire [1:0] tnet_12 = tnet_7;
wire [1:0] tnet_13 = tnet_7;
wire [1:0] tnet_14 = tnet_7;
wire [1:0] tnet_15 = io_in[3:2]; //rd20
wire [1:0] tnet_16 = tnet_15;
wire [1:0] tnet_17 = io_in[1:0]; //ALU

wire [1:0] tnet_18;
wire [1:0] tnet_19;
wire [1:0] tnet_20;
wire [1:0] tnet_21;
wire [1:0] tnet_22;
wire [1:0] tnet_23 = tnet_22;
wire [1:0] tnet_24 = tnet_20;
wire [1:0] tnet_25;
wire [1:0] tnet_26 = tnet_18;
wire [1:0] tnet_27;
wire [1:0] tnet_28;

assign io_out[19:18] = tnet_19; //WriteSel
assign io_out[17:16] = tnet_20; //ALUSel1
assign io_out[15:14] = tnet_21; //ALUSel2
assign io_out[13:12] = tnet_22; //AddrAdd1
assign io_out[11:10] = tnet_23; //AddrAdd1
assign io_out[9:8] = tnet_24; //ALUSel1
assign io_out[7:6] = tnet_25; //JMP1
assign io_out[5:4] = tnet_26; //JMP0
assign io_out[3:2] = tnet_27; //AddrSel
assign io_out[1:0] = tnet_28; //PCSel

f_ZXZ_bet LogicGate_0 (
.portB(tnet_0),
.portA(tnet_7),
.out(tnet_19)
);

f_RDD_bet LogicGate_1 (
.portB(tnet_1),
.portA(tnet_8),
.out(tnet_20)
);

f_HXZHXZ8XZ_bet LogicGate_2 (
.portB(tnet_2),
.portA(tnet_9),
.portC(tnet_15),
.out(tnet_21)
);

f_ZDD_bet LogicGate_3 (
.portB(tnet_3),
.portA(tnet_10),
.out(tnet_22)
);

f_DZZ_bet LogicGate_4 (
.portB(tnet_4),
.portA(tnet_11),
.out(tnet_25)
);

f_EDD_bet LogicGate_5 (
.portB(tnet_5),
.portA(tnet_13),
.out(tnet_27)
);

f_DDDDDDRRD_bet LogicGate_6 (
.portB(tnet_6),
.portA(tnet_14),
.portC(tnet_18),
.out(tnet_28)
);

c_2MUX1 SavedGate_0 (
.io_in({tnet_12,tnet_16,tnet_17}),
.io_out({tnet_18})
);

endmodule

