module c_CarrySelect6 (
     input [23:0] io_in,
     output [13:0] io_out
);

wire [1:0] tnet_0 = io_in[23:22]; //a5
wire [1:0] tnet_1 = io_in[21:20]; //a4
wire [1:0] tnet_2 = io_in[19:18]; //a3
wire [1:0] tnet_3 = io_in[17:16]; //a2
wire [1:0] tnet_4 = tnet_3;
wire [1:0] tnet_5 = io_in[15:14]; //a1
wire [1:0] tnet_6 = io_in[13:12]; //a0
wire [1:0] tnet_7 = io_in[11:10]; //b5
wire [1:0] tnet_8 = io_in[9:8]; //b4
wire [1:0] tnet_9 = io_in[7:6]; //b3
wire [1:0] tnet_10 = io_in[5:4]; //b2
wire [1:0] tnet_11 = tnet_10;
wire [1:0] tnet_12 = io_in[3:2]; //b1
wire [1:0] tnet_13 = io_in[1:0]; //b0

wire [1:0] tnet_14;
wire [1:0] tnet_15;
wire [1:0] tnet_16 = tnet_15;
wire [1:0] tnet_17;
wire [1:0] tnet_18;
wire [1:0] tnet_19;
wire [1:0] tnet_20;
wire [1:0] tnet_21;
wire [1:0] tnet_22;
wire [1:0] tnet_23;
wire [1:0] tnet_24;
wire [1:0] tnet_25;
wire [1:0] tnet_26;
wire [1:0] tnet_27;
wire [1:0] tnet_28;
wire [1:0] tnet_29;
wire [1:0] tnet_30;
wire [1:0] tnet_31;
wire [1:0] tnet_32;

assign io_out[13:12] = tnet_26; //DataOut
assign io_out[11:10] = tnet_27; //DataOut
assign io_out[9:8] = tnet_28; //DataOut
assign io_out[7:6] = tnet_29; //DataOut
assign io_out[5:4] = tnet_30; //DataOut
assign io_out[3:2] = tnet_31; //DataOut
assign io_out[1:0] = tnet_32; //DataOut

f_VP0_bet LogicGate_0 (
.portB(tnet_3),
.portA(tnet_10),
.out(tnet_14)
);

f_T_bet LogicGate_1 (
.portA(tnet_25),
.out(tnet_15)
);

c_2MUX2 SavedGate_0 (
.io_in({tnet_15,tnet_19,tnet_20,tnet_17,tnet_18}),
.io_out({tnet_26,tnet_27})
);

c_carry_select_group_3 SavedGate_1 (
.io_in({tnet_0,tnet_1,tnet_2,tnet_7,tnet_8,tnet_9,tnet_14}),
.io_out({tnet_17,tnet_17,tnet_18,tnet_21,tnet_22,tnet_19,tnet_20,tnet_23,tnet_24})
);

c_2MUX2 SavedGate_2 (
.io_in({tnet_16,tnet_23,tnet_24,tnet_21,tnet_22}),
.io_out({tnet_28,tnet_29})
);

c_3TritRippleCarrry SavedGate_3 (
.io_in({tnet_4,tnet_5,tnet_6,tnet_11,tnet_12,tnet_13}),
.io_out({tnet_25,tnet_25,tnet_30,tnet_31,tnet_32})
);

endmodule

