module c_CarrySelect6 (
     input [23:0] io_in,
     output [13:0] io_out
);

wire [1:0] tnet_0 = io_in[23:22]; //a5
wire [1:0] tnet_1 = io_in[21:20]; //a4
wire [1:0] tnet_2 = io_in[19:18]; //a3
wire [1:0] tnet_3 = io_in[17:16]; //a2
wire [1:0] tnet_4 = tnet_3;
wire [1:0] tnet_5 = io_in[15:14]; //a1
wire [1:0] tnet_6 = io_in[13:12]; //a0
wire [1:0] tnet_7 = io_in[11:10]; //b5
wire [1:0] tnet_8 = io_in[9:8]; //b4
wire [1:0] tnet_9 = io_in[7:6]; //b3
wire [1:0] tnet_10 = io_in[5:4]; //b2
wire [1:0] tnet_11 = tnet_10;
wire [1:0] tnet_12 = io_in[3:2]; //b1
wire [1:0] tnet_13 = io_in[1:0]; //b0

wire [1:0] tnet_14;
wire [1:0] tnet_15;
wire [1:0] tnet_16 = tnet_15;
wire [1:0] tnet_17;
wire [1:0] tnet_18;
wire [1:0] tnet_19;
wire [1:0] tnet_20;
wire [1:0] tnet_21;
wire [1:0] tnet_22;
wire [1:0] tnet_23;
wire [1:0] tnet_24;
wire [1:0] tnet_25;
wire [1:0] tnet_26;
wire [1:0] tnet_27;
wire [1:0] tnet_28;
wire [1:0] tnet_29;
wire [1:0] tnet_30;
wire [1:0] tnet_31;
wire [1:0] tnet_32;

assign io_out[13:12] = tnet_26; //DataOut
assign io_out[11:10] = tnet_27; //DataOut
assign io_out[9:8] = tnet_28; //DataOut
assign io_out[7:6] = tnet_29; //DataOut
assign io_out[5:4] = tnet_30; //DataOut
assign io_out[3:2] = tnet_31; //DataOut
assign io_out[1:0] = tnet_32; //DataOut

f_VP0_bet LogicGate_0 (
.portB(tnet_3),
.portA(tnet_10),
.out(tnet_14)
);

f_T_bet LogicGate_1 (
.portA(tnet_25),
.out(tnet_15)
);

c_2MUX2 SavedGate_0 (
.io_in({tnet_15,tnet_19,tnet_20,tnet_17,tnet_18}),
.io_out({tnet_26,tnet_27})
);

c_carry_select_group_3 SavedGate_1 (
.io_in({tnet_0,tnet_1,tnet_2,tnet_7,tnet_8,tnet_9,tnet_14}),
.io_out({tnet_17,tnet_17,tnet_18,tnet_21,tnet_22,tnet_19,tnet_20,tnet_23,tnet_24})
);

c_2MUX2 SavedGate_2 (
.io_in({tnet_16,tnet_23,tnet_24,tnet_21,tnet_22}),
.io_out({tnet_28,tnet_29})
);

c_3TritRippleCarrry SavedGate_3 (
.io_in({tnet_4,tnet_5,tnet_6,tnet_11,tnet_12,tnet_13}),
.io_out({tnet_25,tnet_25,tnet_30,tnet_31,tnet_32})
);

endmodule

module c_2MUX1 (
     input [5:0] io_in,
     output [1:0] io_out
);

wire [1:0] tnet_0 = io_in[5:4]; //sel
wire [1:0] tnet_1 = io_in[3:2]; //b
wire [1:0] tnet_2 = io_in[1:0]; //a

wire [1:0] tnet_3;

assign io_out[1:0] = tnet_3; //q

f_PPPPPPZD0_bet LogicGate_0 (
.portC(tnet_0),
.portB(tnet_1),
.portA(tnet_2),
.out(tnet_3)
);

endmodule

module c_2MUX2 (
     input [9:0] io_in,
     output [3:0] io_out
);

wire [1:0] tnet_0 = io_in[9:8]; //sel
wire [1:0] tnet_1 = tnet_0;
wire [1:0] tnet_2 = io_in[7:6]; //b1
wire [1:0] tnet_3 = io_in[5:4]; //b0
wire [1:0] tnet_4 = io_in[3:2]; //a1
wire [1:0] tnet_5 = io_in[1:0]; //a0

wire [1:0] tnet_6;
wire [1:0] tnet_7;

assign io_out[3:2] = tnet_6; //q1
assign io_out[1:0] = tnet_7; //q0

c_2MUX1 SavedGate_0 (
.io_in({tnet_0,tnet_2,tnet_4}),
.io_out({tnet_6})
);

c_2MUX1 SavedGate_1 (
.io_in({tnet_1,tnet_3,tnet_5}),
.io_out({tnet_7})
);

endmodule

module c_3TritRippleCarrry (
     input [13:0] io_in,
     output [7:0] io_out
);

wire [1:0] tnet_0 = io_in[13:12]; //a2
wire [1:0] tnet_1 = io_in[11:10]; //a1
wire [1:0] tnet_2 = io_in[9:8]; //a0
wire [1:0] tnet_3 = io_in[7:6]; //b2
wire [1:0] tnet_4 = io_in[5:4]; //b1
wire [1:0] tnet_5 = io_in[3:2]; //b0
wire [1:0] tnet_6 = io_in[1:0]; //carry

wire [1:0] tnet_7;
wire [1:0] tnet_8;
wire [1:0] tnet_9;
wire [1:0] tnet_10;
wire [1:0] tnet_11;
wire [1:0] tnet_12;

assign io_out[7:6] = tnet_9; //carry
assign io_out[5:4] = tnet_10; //out2
assign io_out[3:2] = tnet_11; //out1
assign io_out[1:0] = tnet_12; //out0

c_TriFullAdder SavedGate_0 (
.io_in({tnet_7,tnet_0,tnet_3}),
.io_out({tnet_9,tnet_10})
);

c_TriFullAdder SavedGate_1 (
.io_in({tnet_8,tnet_1,tnet_4}),
.io_out({tnet_7,tnet_11})
);

c_TriFullAdder SavedGate_2 (
.io_in({tnet_6,tnet_2,tnet_5}),
.io_out({tnet_8,tnet_12})
);

endmodule

module c_carry_select_group_3 (
     input [13:0] io_in,
     output [17:0] io_out
);

wire [1:0] tnet_0 = io_in[13:12]; //a2
wire [1:0] tnet_1 = tnet_0;
wire [1:0] tnet_2 = tnet_0;
wire [1:0] tnet_3 = io_in[11:10]; //a1
wire [1:0] tnet_4 = tnet_3;
wire [1:0] tnet_5 = io_in[9:8]; //a0
wire [1:0] tnet_6 = tnet_5;
wire [1:0] tnet_7 = io_in[7:6]; //b2
wire [1:0] tnet_8 = tnet_7;
wire [1:0] tnet_9 = tnet_7;
wire [1:0] tnet_10 = io_in[5:4]; //b1
wire [1:0] tnet_11 = tnet_10;
wire [1:0] tnet_12 = io_in[3:2]; //b0
wire [1:0] tnet_13 = tnet_12;
wire [1:0] tnet_14 = io_in[1:0]; //c-gen
wire [1:0] tnet_15 = tnet_14;

wire [1:0] tnet_16;
wire [1:0] tnet_17;
wire [1:0] tnet_18;
wire [1:0] tnet_19;
wire [1:0] tnet_20;
wire [1:0] tnet_21;
wire [1:0] tnet_22;
wire [1:0] tnet_23;
wire [1:0] tnet_24;
wire [1:0] tnet_25;

assign io_out[17:16] = tnet_17; //c-gen
assign io_out[15:14] = tnet_18; //carry
assign io_out[13:12] = tnet_19; //out2
assign io_out[11:10] = tnet_20; //out1
assign io_out[9:8] = tnet_21; //out0
assign io_out[7:6] = tnet_22; //carry-c
assign io_out[5:4] = tnet_23; //out2-c
assign io_out[3:2] = tnet_24; //out1-c
assign io_out[1:0] = tnet_25; //out0-c

f_VK0_bet LogicGate_0 (
.portB(tnet_2),
.portA(tnet_9),
.out(tnet_17)
);

f_D_bet LogicGate_1 (
.portA(tnet_15),
.out(tnet_16)
);

c_3TritRippleCarrry SavedGate_0 (
.io_in({tnet_0,tnet_3,tnet_5,tnet_7,tnet_10,tnet_12,tnet_16}),
.io_out({tnet_18,tnet_19,tnet_20,tnet_21})
);

c_3TritRippleCarrry SavedGate_1 (
.io_in({tnet_1,tnet_4,tnet_6,tnet_8,tnet_11,tnet_13,tnet_14}),
.io_out({tnet_22,tnet_23,tnet_24,tnet_25})
);

endmodule

module c_TriFullAdder (
     input [5:0] io_in,
     output [3:0] io_out
);

wire [1:0] tnet_0 = io_in[5:4]; //Cin
wire [1:0] tnet_1 = tnet_0;
wire [1:0] tnet_2 = io_in[3:2]; //b
wire [1:0] tnet_3 = tnet_2;
wire [1:0] tnet_4 = io_in[1:0]; //a
wire [1:0] tnet_5 = tnet_4;

wire [1:0] tnet_6;
wire [1:0] tnet_7;

assign io_out[3:2] = tnet_6; //Cout
assign io_out[1:0] = tnet_7; //q

f_XRDRDCDC9_bet LogicGate_0 (
.portC(tnet_1),
.portB(tnet_3),
.portA(tnet_5),
.out(tnet_6)
);

f_B7P7PBPB7_bet LogicGate_1 (
.portC(tnet_0),
.portB(tnet_2),
.portA(tnet_4),
.out(tnet_7)
);

endmodule

module f_B7P7PBPB7_bet (
     input wire[1:0] portC,
     input wire[1:0] portB,
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portC == 2'b01) & (portB == 2'b11) & (portA == 2'b01) ? 2'b10 :
    (portC == 2'b01) & (portB == 2'b10) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b01) & (portB == 2'b01) & (portA == 2'b11) ? 2'b10 :
    (portC == 2'b01) & (portB == 2'b11) & (portA == 2'b11) ? 2'b01 :
    (portC == 2'b01) & (portB == 2'b01) & (portA == 2'b10) ? 2'b01 :
    (portC == 2'b01) & (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b11) & (portB == 2'b01) & (portA == 2'b01) ? 2'b10 :
    (portC == 2'b11) & (portB == 2'b11) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b11) & (portB == 2'b01) & (portA == 2'b11) ? 2'b01 :
    (portC == 2'b11) & (portB == 2'b10) & (portA == 2'b11) ? 2'b10 :
    (portC == 2'b11) & (portB == 2'b11) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b11) & (portB == 2'b10) & (portA == 2'b10) ? 2'b01 :
    (portC == 2'b10) & (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b10) & (portB == 2'b10) & (portA == 2'b01) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b11) & (portA == 2'b11) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b10) & (portA == 2'b11) ? 2'b01 :
    (portC == 2'b10) & (portB == 2'b01) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b11) & (portA == 2'b10) ? 2'b01 :
     2'b11;
endmodule

module f_D_bet (
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
     2'b11;
endmodule

module f_PPPPPPZD0_bet (
     input wire[1:0] portC,
     input wire[1:0] portB,
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portC == 2'b01) & (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b01) & (portB == 2'b11) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b01) & (portB == 2'b10) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b01) & (portB == 2'b01) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b01) & (portB == 2'b11) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b01) & (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b11) & (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b11) & (portB == 2'b10) & (portA == 2'b01) ? 2'b10 :
    (portC == 2'b11) & (portB == 2'b01) & (portA == 2'b11) ? 2'b01 :
    (portC == 2'b11) & (portB == 2'b10) & (portA == 2'b11) ? 2'b10 :
    (portC == 2'b11) & (portB == 2'b01) & (portA == 2'b10) ? 2'b01 :
    (portC == 2'b11) & (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b10) & (portB == 2'b10) & (portA == 2'b01) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b01) & (portA == 2'b11) ? 2'b01 :
    (portC == 2'b10) & (portB == 2'b10) & (portA == 2'b11) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b01) & (portA == 2'b10) ? 2'b01 :
    (portC == 2'b10) & (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
     2'b11;
endmodule

module f_T_bet (
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portA == 2'b01) ? 2'b10 :
    (portA == 2'b10) ? 2'b10 :
     2'b11;
endmodule

module f_VK0_bet (
     input wire[1:0] portB,
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b11) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b10) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b01) & (portA == 2'b11) ? 2'b01 :
    (portB == 2'b11) & (portA == 2'b11) ? 2'b01 :
    (portB == 2'b10) & (portA == 2'b11) ? 2'b10 :
    (portB == 2'b01) & (portA == 2'b10) ? 2'b01 :
    (portB == 2'b11) & (portA == 2'b10) ? 2'b10 :
    (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
     2'b11;
endmodule

module f_VP0_bet (
     input wire[1:0] portB,
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b11) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b10) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b01) & (portA == 2'b11) ? 2'b01 :
    (portB == 2'b10) & (portA == 2'b11) ? 2'b10 :
    (portB == 2'b01) & (portA == 2'b10) ? 2'b01 :
    (portB == 2'b11) & (portA == 2'b10) ? 2'b10 :
    (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
     2'b11;
endmodule

module f_XRDRDCDC9_bet (
     input wire[1:0] portC,
     input wire[1:0] portB,
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portC == 2'b01) & (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b01) & (portB == 2'b11) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b01) & (portB == 2'b01) & (portA == 2'b11) ? 2'b01 :
    (portC == 2'b11) & (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b11) & (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b10) & (portA == 2'b11) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b11) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
     2'b11;
endmodule

