module c_Decode (
     input [35:0] io_in,
     output [35:0] io_out
);

wire [1:0] tnet_0 = io_in[31:30]; //Opcode1
wire [1:0] tnet_1 = io_in[29:28]; //Opcode0
wire [1:0] tnet_2 = io_in[27:26]; //Rs11
wire [1:0] tnet_3 = io_in[25:24]; //Rs10
wire [1:0] tnet_4 = io_in[23:22]; //Rs21
wire [1:0] tnet_5 = tnet_4;
wire [1:0] tnet_6 = io_in[21:20]; //Rs20
wire [1:0] tnet_7 = tnet_6;
wire [1:0] tnet_8 = io_in[19:18]; //Rd11
wire [1:0] tnet_9 = io_in[17:16]; //Rd10
wire [1:0] tnet_10 = io_in[15:14]; //Rd21
wire [1:0] tnet_11 = tnet_10;
wire [1:0] tnet_12 = io_in[13:12]; //Rd20
wire [1:0] tnet_13 = tnet_12;
wire [1:0] tnet_14 = io_in[11:10]; //RegWb
wire [1:0] tnet_15 = io_in[9:8]; //WrAddr1
wire [1:0] tnet_16 = io_in[7:6]; //WrAddr0
wire [1:0] tnet_17 = io_in[5:4]; //WrData1
wire [1:0] tnet_18 = io_in[3:2]; //WrData0
wire [1:0] tnet_19 = io_in[1:0]; //Clock

wire [1:0] tnet_20;
wire [1:0] tnet_21;
wire [1:0] tnet_22;
wire [1:0] tnet_23;
wire [1:0] tnet_24;
wire [1:0] tnet_25;
wire [1:0] tnet_26;
wire [1:0] tnet_27;
wire [1:0] tnet_28;
wire [1:0] tnet_29;
wire [1:0] tnet_30;
wire [1:0] tnet_31;
wire [1:0] tnet_32;

assign io_out[35:34] = tnet_21; //AluCtrl2
assign io_out[33:32] = tnet_22; //AluCtrl1
assign io_out[31:30] = tnet_23; //AluCtrl0
assign io_out[29:28] = tnet_24; //AluASel
assign io_out[27:26] = tnet_25; //AluBSel
assign io_out[25:24] = tnet_26; //AddSel1
assign io_out[23:22] = tnet_27; //AddSel0
assign io_out[21:20] = tnet_28; //TarSel
assign io_out[19:18] = tnet_29; //Reg11
assign io_out[17:16] = tnet_30; //Reg10
assign io_out[15:14] = tnet_31; //Reg21
assign io_out[13:12] = tnet_32; //Reg20
assign io_out[11:10] = tnet_5; //Imm11
assign io_out[9:8] = tnet_7; //Imm10
assign io_out[7:6] = tnet_8; //TarAddr1
assign io_out[5:4] = tnet_9; //TarAddr0
assign io_out[3:2] = tnet_11; //Imm21
assign io_out[1:0] = tnet_13; //Imm20

f_K00_bet LogicGate_0 (
.portB(tnet_14),
.portA(tnet_19),
.out(tnet_20)
);

c_ExecCtrl SavedGate_0 (
.io_in({tnet_0,tnet_1,tnet_10,tnet_12}),
.io_out({tnet_21,tnet_22,tnet_23,tnet_24,tnet_25,tnet_26,tnet_27,tnet_28})
);

c_9REG2 SavedGate_1 (
.io_in({tnet_2,tnet_3,tnet_4,tnet_6,tnet_15,tnet_16,tnet_17,tnet_18,tnet_20[1]}),
.io_out({tnet_29,tnet_30,tnet_31,tnet_32})
);

endmodule

