module c_Increment2 (
     input [3:0] io_in,
     output [3:0] io_out
);

wire [1:0] tnet_0 = io_in[3:2]; //x1
wire [1:0] tnet_1 = io_in[1:0]; //x0
wire [1:0] tnet_2 = tnet_1;

wire [1:0] tnet_3;
wire [1:0] tnet_4;

assign io_out[3:2] = tnet_3; //DataOut
assign io_out[1:0] = tnet_4; //DataOut

f_7PP_bet LogicGate_0 (
.portB(tnet_0),
.portA(tnet_2),
.out(tnet_3)
);

f_7_bet LogicGate_1 (
.portA(tnet_1),
.out(tnet_4)
);

endmodule

module f_7PP_bet (
     input wire[1:0] portB,
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b10) & (portA == 2'b01) ? 2'b10 :
    (portB == 2'b01) & (portA == 2'b11) ? 2'b01 :
    (portB == 2'b10) & (portA == 2'b11) ? 2'b10 :
    (portB == 2'b11) & (portA == 2'b10) ? 2'b10 :
    (portB == 2'b10) & (portA == 2'b10) ? 2'b01 :
     2'b11;
endmodule

module f_7_bet (
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portA == 2'b11) ? 2'b10 :
    (portA == 2'b10) ? 2'b01 :
     2'b11;
endmodule

