module c_balanced_unbalanced_lookahead (
     input [11:0] io_in,
     output [7:0] io_out
);

wire [1:0] tnet_0 = io_in[11:10]; //a2
wire [1:0] tnet_1 = tnet_0;
wire [1:0] tnet_2 = tnet_0;
wire [1:0] tnet_3 = tnet_0;
wire [1:0] tnet_4 = io_in[9:8]; //a1
wire [1:0] tnet_5 = io_in[7:6]; //a0
wire [1:0] tnet_6 = io_in[5:4]; //b2
wire [1:0] tnet_7 = io_in[3:2]; //b1
wire [1:0] tnet_8 = io_in[1:0]; //b0

wire [1:0] tnet_9;
wire [1:0] tnet_10 = tnet_9;
wire [1:0] tnet_11 = tnet_9;
wire [1:0] tnet_12 = tnet_9;
wire [1:0] tnet_13 = tnet_9;
wire [1:0] tnet_14;
wire [1:0] tnet_15;
wire [1:0] tnet_16 = tnet_15;
wire [1:0] tnet_17;
wire bnet_18;
wire bnet_19;
wire [1:0] tnet_20;
wire bnet_21;
wire bnet_22;
wire bnet_23;
wire bnet_24;
wire bnet_25;
wire bnet_26;
wire bnet_27;
wire bnet_28;
wire bnet_29;
wire bnet_30;
wire [1:0] tnet_31;
wire bnet_32;
wire bnet_33;
wire bnet_34;
wire bnet_35;
wire [1:0] tnet_36;
wire bnet_37;
wire bnet_38;
wire [1:0] tnet_39;
wire [1:0] tnet_40;
wire [1:0] tnet_41;
wire [1:0] tnet_42;

assign io_out[7:6] = tnet_39; //c
assign io_out[5:4] = tnet_40; //q2
assign io_out[3:2] = tnet_41; //q1
assign io_out[1:0] = tnet_42; //q0

f_0_bet LogicGate_0 (
.portA(tnet_0),
.out(tnet_9)
);

f_Z_bet LogicGate_1 (
.portA(tnet_2),
.out(tnet_14)
);

f_D_bet LogicGate_2 (
.portA(tnet_3),
.out(tnet_15)
);

f_C_bet LogicGate_3 (
.portA({bnet_30,!bnet_30}),
.out(tnet_17)
);

c_unbalaced_partial_full_adder SavedGate_0 (
.io_in({tnet_9,tnet_17,bnet_25}),
.io_out({tnet_39,tnet_39,tnet_39})
);

c_unbalaced_partial_full_adder SavedGate_1 (
.io_in({tnet_15,tnet_20,bnet_24}),
.io_out({bnet_19,bnet_18,tnet_40})
);

c_unbalaced_partial_full_adder SavedGate_2 (
.io_in({tnet_1,tnet_6,bnet_29}),
.io_out({bnet_21,bnet_22,tnet_20})
);

c_binary_lookahead_3 SavedGate_3 (
.io_in({bnet_19,bnet_18,bnet_27,bnet_26,bnet_35,bnet_34,tnet_13[1]}),
.io_out({bnet_23,bnet_23,bnet_25,bnet_24,bnet_23})
);

c_unbalaced_partial_full_adder SavedGate_4 (
.io_in({tnet_16,tnet_31,bnet_23}),
.io_out({bnet_27,bnet_26,tnet_41})
);

c_binary_lookahead_3 SavedGate_5 (
.io_in({bnet_21,bnet_22,bnet_32,bnet_33,bnet_37,bnet_38,tnet_11[1]}),
.io_out({bnet_30,bnet_28,bnet_28,bnet_29,bnet_28})
);

c_unbalaced_partial_full_adder SavedGate_6 (
.io_in({tnet_4,tnet_7,bnet_28}),
.io_out({bnet_32,bnet_33,tnet_31})
);

c_unbalaced_partial_full_adder SavedGate_7 (
.io_in({tnet_14,tnet_36,tnet_12[1]}),
.io_out({bnet_35,bnet_34,tnet_42})
);

c_unbalaced_partial_full_adder SavedGate_8 (
.io_in({tnet_5,tnet_8,tnet_10[1]}),
.io_out({bnet_37,bnet_38,tnet_36})
);

endmodule

module c_binary_lookahead_3 (
     input [6:0] io_in,
     output [4:0] io_out
);

wire bnet_0 = io_in[6]; //g2
wire bnet_1 = io_in[5]; //p2
wire bnet_2 = bnet_1;
wire bnet_3 = bnet_1;
wire bnet_4 = io_in[4]; //g1
wire bnet_5 = bnet_4;
wire bnet_6 = io_in[3]; //p1
wire bnet_7 = bnet_6;
wire bnet_8 = bnet_6;
wire bnet_9 = bnet_6;
wire bnet_10 = io_in[2]; //g0
wire bnet_11 = bnet_10;
wire bnet_12 = bnet_10;
wire bnet_13 = io_in[1]; //p0
wire bnet_14 = bnet_13;
wire bnet_15 = bnet_13;
wire bnet_16 = io_in[0]; //carry
wire bnet_17 = bnet_16;
wire bnet_18 = bnet_16;

wire bnet_19;
wire bnet_20;
wire bnet_21;
wire bnet_22;
wire bnet_23;
wire bnet_24;
wire bnet_25 = bnet_21;
wire bnet_26 = bnet_19;
wire bnet_27;
wire bnet_28;
wire bnet_29;

assign io_out[4] = bnet_25; //G
assign io_out[3] = bnet_26; //P
assign io_out[2] = bnet_27; //c3
assign io_out[1] = bnet_28; //c2
assign io_out[0] = bnet_29; //c1

f_K00000000 LogicGate_0 (
.portC(bnet_1),
.portB(bnet_6),
.portA(bnet_13),
.out(bnet_19)
);

f_ZZZK00K00 LogicGate_1 (
.portA(bnet_16),
.portB(bnet_19),
.portC(bnet_21),
.out(bnet_27)
);

f_K00000000 LogicGate_2 (
.portC(bnet_2),
.portB(bnet_7),
.portA(bnet_10),
.out(bnet_20)
);

f_ZZZZKKZKK LogicGate_3 (
.portC(bnet_0),
.portB(bnet_20),
.portA(bnet_22),
.out(bnet_21)
);

f_K00 LogicGate_4 (
.portB(bnet_3),
.portA(bnet_4),
.out(bnet_22)
);

f_K00000000 LogicGate_5 (
.portC(bnet_8),
.portB(bnet_14),
.portA(bnet_17),
.out(bnet_23)
);

f_ZZZK00K00 LogicGate_6 (
.portC(bnet_5),
.portB(bnet_9),
.portA(bnet_11),
.out(bnet_24)
);

f_ZKK LogicGate_7 (
.portB(bnet_23),
.portA(bnet_24),
.out(bnet_28)
);

f_ZZZK00K00 LogicGate_8 (
.portC(bnet_12),
.portB(bnet_15),
.portA(bnet_18),
.out(bnet_29)
);

endmodule

module c_unbalaced_partial_full_adder (
     input [4:0] io_in,
     output [3:0] io_out
);

wire [1:0] tnet_0 = io_in[4:3]; //a
wire [1:0] tnet_1 = tnet_0;
wire [1:0] tnet_2 = tnet_0;
wire [1:0] tnet_3 = io_in[2:1]; //b
wire [1:0] tnet_4 = tnet_3;
wire [1:0] tnet_5 = tnet_3;
wire bnet_6 = io_in[0]; //c

wire [1:0] tnet_7;
wire [1:0] tnet_8;
wire [1:0] tnet_9;

assign io_out[3] = tnet_7[1]; //g
assign io_out[2] = tnet_8[1]; //p
assign io_out[1:0] = tnet_9; //out

f_VK0_bet LogicGate_0 (
.portB(tnet_2),
.portA(tnet_5),
.out(tnet_7)
);

f_ZVK_bet LogicGate_1 (
.portB(tnet_1),
.portA(tnet_4),
.out(tnet_8)
);

f_PB7PB7B7P_bet LogicGate_2 (
.portB(tnet_0),
.portA(tnet_3),
.portC({bnet_6,!bnet_6}),
.out(tnet_9)
);

endmodule

module f_0_bet (
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portA == 2'b01) ? 2'b01 :
    (portA == 2'b11) ? 2'b01 :
    (portA == 2'b10) ? 2'b01 :
     2'b11;
endmodule

module f_C_bet (
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portA == 2'b01) ? 2'b01 :
     2'b11;
endmodule

module f_D_bet (
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
     2'b11;
endmodule

module f_K00 (
     input wire portB,
     input wire portA,
     output wire out
     );

     assign out = 
    (portB == 1 & portA == 1);
endmodule

module f_K00000000 (
     input wire portC,
     input wire portB,
     input wire portA,
     output wire out
     );

     assign out = 
    (portC == 1 & portB == 1 & portA == 1);
endmodule

module f_PB7PB7B7P_bet (
     input wire[1:0] portC,
     input wire[1:0] portB,
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portC == 2'b01) & (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b01) & (portB == 2'b10) & (portA == 2'b01) ? 2'b10 :
    (portC == 2'b01) & (portB == 2'b11) & (portA == 2'b11) ? 2'b10 :
    (portC == 2'b01) & (portB == 2'b10) & (portA == 2'b11) ? 2'b01 :
    (portC == 2'b01) & (portB == 2'b01) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b01) & (portB == 2'b11) & (portA == 2'b10) ? 2'b01 :
    (portC == 2'b11) & (portB == 2'b11) & (portA == 2'b01) ? 2'b10 :
    (portC == 2'b11) & (portB == 2'b10) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b11) & (portB == 2'b01) & (portA == 2'b11) ? 2'b10 :
    (portC == 2'b11) & (portB == 2'b11) & (portA == 2'b11) ? 2'b01 :
    (portC == 2'b11) & (portB == 2'b01) & (portA == 2'b10) ? 2'b01 :
    (portC == 2'b11) & (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b11) & (portA == 2'b01) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b10) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b10) & (portB == 2'b01) & (portA == 2'b11) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b11) & (portA == 2'b11) ? 2'b01 :
    (portC == 2'b10) & (portB == 2'b01) & (portA == 2'b10) ? 2'b01 :
    (portC == 2'b10) & (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
     2'b11;
endmodule

module f_VK0_bet (
     input wire[1:0] portB,
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b11) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b10) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b01) & (portA == 2'b11) ? 2'b01 :
    (portB == 2'b11) & (portA == 2'b11) ? 2'b01 :
    (portB == 2'b10) & (portA == 2'b11) ? 2'b10 :
    (portB == 2'b01) & (portA == 2'b10) ? 2'b01 :
    (portB == 2'b11) & (portA == 2'b10) ? 2'b10 :
    (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
     2'b11;
endmodule

module f_ZKK (
     input wire portB,
     input wire portA,
     output wire out
     );

     assign out = 
    (portB == 1 & portA == 0) |
    (portB == 0 & portA == 1) |
    (portB == 1 & portA == 1);
endmodule

module f_ZVK_bet (
     input wire[1:0] portB,
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b11) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b10) & (portA == 2'b01) ? 2'b10 :
    (portB == 2'b01) & (portA == 2'b11) ? 2'b01 :
    (portB == 2'b11) & (portA == 2'b11) ? 2'b10 :
    (portB == 2'b10) & (portA == 2'b11) ? 2'b10 :
    (portB == 2'b01) & (portA == 2'b10) ? 2'b10 :
    (portB == 2'b11) & (portA == 2'b10) ? 2'b10 :
    (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
     2'b11;
endmodule

module f_ZZZK00K00 (
     input wire portC,
     input wire portB,
     input wire portA,
     output wire out
     );

     assign out = 
    (portC == 0 & portB == 1 & portA == 1) |
    (portC == 1 & portB == 0 & portA == 0) |
    (portC == 1 & portB == 1 & portA == 0) |
    (portC == 1 & portB == 0 & portA == 1) |
    (portC == 1 & portB == 1 & portA == 1);
endmodule

module f_ZZZZKKZKK (
     input wire portC,
     input wire portB,
     input wire portA,
     output wire out
     );

     assign out = 
    (portC == 0 & portB == 1 & portA == 0) |
    (portC == 0 & portB == 0 & portA == 1) |
    (portC == 0 & portB == 1 & portA == 1) |
    (portC == 1 & portB == 0 & portA == 0) |
    (portC == 1 & portB == 1 & portA == 0) |
    (portC == 1 & portB == 0 & portA == 1) |
    (portC == 1 & portB == 1 & portA == 1);
endmodule

module f_Z_bet (
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portA == 2'b01) ? 2'b10 :
    (portA == 2'b11) ? 2'b10 :
    (portA == 2'b10) ? 2'b10 :
     2'b11;
endmodule

