module c_carry_select_group_3 (
     input [13:0] io_in,
     output [17:0] io_out
);

wire [1:0] tnet_0 = io_in[13:12]; //a2
wire [1:0] tnet_1 = tnet_0;
wire [1:0] tnet_2 = tnet_0;
wire [1:0] tnet_3 = io_in[11:10]; //a1
wire [1:0] tnet_4 = tnet_3;
wire [1:0] tnet_5 = io_in[9:8]; //a0
wire [1:0] tnet_6 = tnet_5;
wire [1:0] tnet_7 = io_in[7:6]; //b2
wire [1:0] tnet_8 = tnet_7;
wire [1:0] tnet_9 = tnet_7;
wire [1:0] tnet_10 = io_in[5:4]; //b1
wire [1:0] tnet_11 = tnet_10;
wire [1:0] tnet_12 = io_in[3:2]; //b0
wire [1:0] tnet_13 = tnet_12;
wire [1:0] tnet_14 = io_in[1:0]; //c-gen
wire [1:0] tnet_15 = tnet_14;

wire [1:0] tnet_16;
wire [1:0] tnet_17;
wire [1:0] tnet_18;
wire [1:0] tnet_19;
wire [1:0] tnet_20;
wire [1:0] tnet_21;
wire [1:0] tnet_22;
wire [1:0] tnet_23;
wire [1:0] tnet_24;
wire [1:0] tnet_25;

assign io_out[17:16] = tnet_17; //c-gen
assign io_out[15:14] = tnet_18; //carry
assign io_out[13:12] = tnet_19; //out2
assign io_out[11:10] = tnet_20; //out1
assign io_out[9:8] = tnet_21; //out0
assign io_out[7:6] = tnet_22; //carry-c
assign io_out[5:4] = tnet_23; //out2-c
assign io_out[3:2] = tnet_24; //out1-c
assign io_out[1:0] = tnet_25; //out0-c

f_VK0_bet LogicGate_0 (
.portB(tnet_2),
.portA(tnet_9),
.out(tnet_17)
);

f_D_bet LogicGate_1 (
.portA(tnet_15),
.out(tnet_16)
);

c_3TritRippleCarrry SavedGate_0 (
.io_in({tnet_0,tnet_3,tnet_5,tnet_7,tnet_10,tnet_12,tnet_16}),
.io_out({tnet_18,tnet_19,tnet_20,tnet_21})
);

c_3TritRippleCarrry SavedGate_1 (
.io_in({tnet_1,tnet_4,tnet_6,tnet_8,tnet_11,tnet_13,tnet_14}),
.io_out({tnet_22,tnet_23,tnet_24,tnet_25})
);

endmodule

