module c_count2 (
     input [6:0] io_in,
     output [3:0] io_out
);

wire bnet_0 = io_in[6]; //clk
wire bnet_1 = io_in[5]; //enable
wire bnet_2 = io_in[4]; //load
wire bnet_3 = bnet_2;
wire [1:0] tnet_4 = io_in[3:2]; //d1
wire [1:0] tnet_5 = io_in[1:0]; //d0

wire bnet_6;
wire bnet_7 = bnet_6;
wire [1:0] tnet_8;
wire [1:0] tnet_9;
wire [1:0] tnet_10;
wire [1:0] tnet_11;
wire [1:0] tnet_12;
wire [1:0] tnet_13;
wire [1:0] tnet_14 = tnet_8;
wire [1:0] tnet_15 = tnet_11;

assign io_out[3:2] = tnet_14; //q1
assign io_out[1:0] = tnet_15; //q0

f_KKK00K00K LogicGate_0 (
.portB(bnet_0),
.portA(bnet_1),
.portC(bnet_2),
.out(bnet_6)
);

c_DLatchEdge SavedGate_0 (
.io_in({tnet_9,bnet_6}),
.io_out({tnet_8})
);

c_2MUX2 SavedGate_1 (
.io_in({{bnet_3,!bnet_3},tnet_4,tnet_5,tnet_12,tnet_13}),
.io_out({tnet_9,tnet_10})
);

c_DLatchEdge SavedGate_2 (
.io_in({tnet_10,bnet_7}),
.io_out({tnet_11})
);

c_Increment2 SavedGate_3 (
.io_in({tnet_8,tnet_11}),
.io_out({tnet_12,tnet_13})
);

endmodule

module c_2MUX1 (
     input [5:0] io_in,
     output [1:0] io_out
);

wire [1:0] tnet_0 = io_in[5:4]; //sel
wire [1:0] tnet_1 = io_in[3:2]; //b
wire [1:0] tnet_2 = io_in[1:0]; //a

wire [1:0] tnet_3;

assign io_out[1:0] = tnet_3; //q

f_PPPPPPZD0_bet LogicGate_0 (
.portC(tnet_0),
.portB(tnet_1),
.portA(tnet_2),
.out(tnet_3)
);

endmodule

module c_2MUX2 (
     input [9:0] io_in,
     output [3:0] io_out
);

wire [1:0] tnet_0 = io_in[9:8]; //sel
wire [1:0] tnet_1 = tnet_0;
wire [1:0] tnet_2 = io_in[7:6]; //b1
wire [1:0] tnet_3 = io_in[5:4]; //b0
wire [1:0] tnet_4 = io_in[3:2]; //a1
wire [1:0] tnet_5 = io_in[1:0]; //a0

wire [1:0] tnet_6;
wire [1:0] tnet_7;

assign io_out[3:2] = tnet_6; //q1
assign io_out[1:0] = tnet_7; //q0

c_2MUX1 SavedGate_0 (
.io_in({tnet_0,tnet_2,tnet_4}),
.io_out({tnet_6})
);

c_2MUX1 SavedGate_1 (
.io_in({tnet_1,tnet_3,tnet_5}),
.io_out({tnet_7})
);

endmodule

module c_BTLatch (
     input [2:0] io_in,
     output [1:0] io_out
);

wire bnet_0 = io_in[2]; //DataIn
wire [1:0] tnet_1 = io_in[1:0]; //DataIn

wire [1:0] tnet_2;
wire [1:0] tnet_3 = tnet_2;

assign io_out[1:0] = tnet_3; //DataOut

f_ZD0PPPPPP_bet LogicGate_0 (
.portC({bnet_0,!bnet_0}),
.portA(tnet_1),
.portB(tnet_2),
.out(tnet_2)
);

endmodule

module c_DLatchEdge (
     input [2:0] io_in,
     output [1:0] io_out
);

wire [1:0] tnet_0 = io_in[2:1]; //DataIn
wire bnet_1 = io_in[0]; //Clk

wire bnet_2;
wire bnet_3 = bnet_2;
wire bnet_4;
wire [1:0] tnet_5;
wire [1:0] tnet_6;

assign io_out[1:0] = tnet_6; //DataOut

f_2 LogicGate_0 (
.portA(bnet_1),
.out(bnet_2)
);

f_2 LogicGate_1 (
.portA(bnet_2),
.out(bnet_4)
);

c_BTLatch SavedGate_0 (
.io_in({bnet_4,tnet_5}),
.io_out({tnet_6})
);

c_BTLatch SavedGate_1 (
.io_in({bnet_3,tnet_0}),
.io_out({tnet_5})
);

endmodule

module c_Increment2 (
     input [3:0] io_in,
     output [3:0] io_out
);

wire [1:0] tnet_0 = io_in[3:2]; //x1
wire [1:0] tnet_1 = io_in[1:0]; //x0
wire [1:0] tnet_2 = tnet_1;

wire [1:0] tnet_3;
wire [1:0] tnet_4;

assign io_out[3:2] = tnet_3; //DataOut
assign io_out[1:0] = tnet_4; //DataOut

f_7PP_bet LogicGate_0 (
.portB(tnet_0),
.portA(tnet_2),
.out(tnet_3)
);

f_7_bet LogicGate_1 (
.portA(tnet_1),
.out(tnet_4)
);

endmodule

module f_2 (
     input wire portA,
     output wire out
     );

     assign out = 
    (portA == 0);
endmodule

module f_7PP_bet (
     input wire[1:0] portB,
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b10) & (portA == 2'b01) ? 2'b10 :
    (portB == 2'b01) & (portA == 2'b11) ? 2'b01 :
    (portB == 2'b10) & (portA == 2'b11) ? 2'b10 :
    (portB == 2'b11) & (portA == 2'b10) ? 2'b10 :
    (portB == 2'b10) & (portA == 2'b10) ? 2'b01 :
     2'b11;
endmodule

module f_7_bet (
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portA == 2'b11) ? 2'b10 :
    (portA == 2'b10) ? 2'b01 :
     2'b11;
endmodule

module f_KKK00K00K (
     input wire portC,
     input wire portB,
     input wire portA,
     output wire out
     );

     assign out = 
    (portC == 0 & portB == 1 & portA == 0) |
    (portC == 1 & portB == 1 & portA == 0) |
    (portC == 1 & portB == 1 & portA == 1);
endmodule

module f_PPPPPPZD0_bet (
     input wire[1:0] portC,
     input wire[1:0] portB,
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portC == 2'b01) & (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b01) & (portB == 2'b11) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b01) & (portB == 2'b10) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b01) & (portB == 2'b01) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b01) & (portB == 2'b11) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b01) & (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b11) & (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b11) & (portB == 2'b10) & (portA == 2'b01) ? 2'b10 :
    (portC == 2'b11) & (portB == 2'b01) & (portA == 2'b11) ? 2'b01 :
    (portC == 2'b11) & (portB == 2'b10) & (portA == 2'b11) ? 2'b10 :
    (portC == 2'b11) & (portB == 2'b01) & (portA == 2'b10) ? 2'b01 :
    (portC == 2'b11) & (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b10) & (portB == 2'b10) & (portA == 2'b01) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b01) & (portA == 2'b11) ? 2'b01 :
    (portC == 2'b10) & (portB == 2'b10) & (portA == 2'b11) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b01) & (portA == 2'b10) ? 2'b01 :
    (portC == 2'b10) & (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
     2'b11;
endmodule

module f_ZD0PPPPPP_bet (
     input wire[1:0] portC,
     input wire[1:0] portB,
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portC == 2'b01) & (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b01) & (portB == 2'b10) & (portA == 2'b01) ? 2'b10 :
    (portC == 2'b01) & (portB == 2'b01) & (portA == 2'b11) ? 2'b01 :
    (portC == 2'b01) & (portB == 2'b10) & (portA == 2'b11) ? 2'b10 :
    (portC == 2'b01) & (portB == 2'b01) & (portA == 2'b10) ? 2'b01 :
    (portC == 2'b01) & (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b11) & (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b11) & (portB == 2'b10) & (portA == 2'b01) ? 2'b10 :
    (portC == 2'b11) & (portB == 2'b01) & (portA == 2'b11) ? 2'b01 :
    (portC == 2'b11) & (portB == 2'b10) & (portA == 2'b11) ? 2'b10 :
    (portC == 2'b11) & (portB == 2'b01) & (portA == 2'b10) ? 2'b01 :
    (portC == 2'b11) & (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b10) & (portB == 2'b11) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b10) & (portB == 2'b10) & (portA == 2'b01) ? 2'b01 :
    (portC == 2'b10) & (portB == 2'b01) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b11) & (portA == 2'b10) ? 2'b10 :
    (portC == 2'b10) & (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
     2'b11;
endmodule

