module c_hackaday_full_select_adder (
     input [9:0] io_in,
     output [11:0] io_out
);

wire [1:0] tnet_0 = io_in[9:8]; //a
wire [1:0] tnet_1 = tnet_0;
wire [1:0] tnet_2 = io_in[7:6]; //b
wire [1:0] tnet_3 = tnet_2;
wire [1:0] tnet_4 = io_in[5:4]; //c-n
wire [1:0] tnet_5 = io_in[3:2]; //c-z
wire [1:0] tnet_6 = io_in[1:0]; //c-p

wire [1:0] tnet_7;
wire [1:0] tnet_8 = tnet_7;
wire [1:0] tnet_9 = tnet_7;
wire [1:0] tnet_10;
wire [1:0] tnet_11;
wire [1:0] tnet_12;
wire [1:0] tnet_13;
wire [1:0] tnet_14 = tnet_13;
wire [1:0] tnet_15 = tnet_13;
wire [1:0] tnet_16 = tnet_13;
wire [1:0] tnet_17 = tnet_13;
wire [1:0] tnet_18;
wire [1:0] tnet_19;
wire [1:0] tnet_20;
wire [1:0] tnet_21;
wire [1:0] tnet_22 = tnet_13;
wire [1:0] tnet_23;

assign io_out[11:10] = tnet_18; //c-n
assign io_out[9:8] = tnet_19; //c-z
assign io_out[7:6] = tnet_20; //c-p
assign io_out[5:4] = tnet_21; //s-n
assign io_out[3:2] = tnet_22; //s-z
assign io_out[1:0] = tnet_23; //s-p

f_B_bet LogicGate_0 (
.portA(tnet_16),
.out(tnet_21)
);

f_7_bet LogicGate_1 (
.portA(tnet_17),
.out(tnet_23)
);

c_sum SavedGate_0 (
.io_in({tnet_7,tnet_10}),
.io_out({tnet_18})
);

c_con SavedGate_1 (
.io_in({tnet_0,tnet_2}),
.io_out({tnet_7})
);

c_sum SavedGate_2 (
.io_in({tnet_8,tnet_11}),
.io_out({tnet_19})
);

c_sum SavedGate_3 (
.io_in({tnet_9,tnet_12}),
.io_out({tnet_20})
);

c_con SavedGate_4 (
.io_in({tnet_13,tnet_4}),
.io_out({tnet_10})
);

c_con SavedGate_5 (
.io_in({tnet_14,tnet_5}),
.io_out({tnet_11})
);

c_con SavedGate_6 (
.io_in({tnet_15,tnet_6}),
.io_out({tnet_12})
);

c_sum SavedGate_7 (
.io_in({tnet_1,tnet_3}),
.io_out({tnet_13})
);

endmodule

module c_con (
     input [3:0] io_in,
     output [1:0] io_out
);

wire [1:0] tnet_0 = io_in[3:2]; //a
wire [1:0] tnet_1 = io_in[1:0]; //b

wire [1:0] tnet_2;

assign io_out[1:0] = tnet_2; //con

f_RDC_bet LogicGate_0 (
.portB(tnet_0),
.portA(tnet_1),
.out(tnet_2)
);

endmodule

module c_sum (
     input [3:0] io_in,
     output [1:0] io_out
);

wire [1:0] tnet_0 = io_in[3:2]; //a
wire [1:0] tnet_1 = io_in[1:0]; //b

wire [1:0] tnet_2;

assign io_out[1:0] = tnet_2; //sum

f_7PB_bet LogicGate_0 (
.portB(tnet_0),
.portA(tnet_1),
.out(tnet_2)
);

endmodule

module f_7PB_bet (
     input wire[1:0] portB,
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portB == 2'b01) & (portA == 2'b01) ? 2'b10 :
    (portB == 2'b11) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b01) & (portA == 2'b11) ? 2'b01 :
    (portB == 2'b10) & (portA == 2'b11) ? 2'b10 :
    (portB == 2'b11) & (portA == 2'b10) ? 2'b10 :
    (portB == 2'b10) & (portA == 2'b10) ? 2'b01 :
     2'b11;
endmodule

module f_7_bet (
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portA == 2'b11) ? 2'b10 :
    (portA == 2'b10) ? 2'b01 :
     2'b11;
endmodule

module f_B_bet (
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portA == 2'b01) ? 2'b10 :
    (portA == 2'b11) ? 2'b01 :
     2'b11;
endmodule

module f_RDC_bet (
     input wire[1:0] portB,
     input wire[1:0] portA,
     output wire[1:0] out
     );

     assign out = 
    (portB == 2'b01) & (portA == 2'b01) ? 2'b01 :
    (portB == 2'b10) & (portA == 2'b10) ? 2'b10 :
     2'b11;
endmodule

